cordova.define("digital-noventi-notification.NotificationPlugin", function(require, exports, module) {
var _createClass = function () {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
        }
    }

    return function (Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
    };
}();

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

var exec = require('cordova/exec');

var NotificationPlugin = function () {
    function NotificationPlugin(params) {
        var _this = this;
        _classCallCheck(this, NotificationPlugin);

        this.handlers = {
            registration: [],
            notification: [],
            error: []
        };

        this.params = params;

        // triggered on registration and notification
        var success = function success(result) {
            //if (result === 'true') {
            //    _this.emit('registration', true);
            //} else if (result === 'false') {
            //    _this.emit('registration', false);
            //}
            //if (result && typeof result.registrationId !== 'undefined') {
            //    _this.emit('registration', result);
            //}
            //else if (result && result.additionalData && typeof result.additionalData.actionCallback !== 'undefined') {
            //    var executeFuctionOrEmitEventByName = function executeFuctionOrEmitEventByName(functionName, context) {
            //        for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            //            args[_key - 2] = arguments[_key];
            //        }
            //
            //        var namespaces = functionName.split('.');
            //        var func = namespaces.pop();
            //        for (var i = 0; i < namespaces.length; i++) {
            //            context = context[namespaces[i]];
            //        }
            //
            //        if (typeof context[func] === 'function') {
            //            context[func].call(context, args);
            //        } else {
            //            _this.emit(functionName, args);
            //        }
            //    };
            //
            //    executeFuctionOrEmitEventByName(result.additionalData.actionCallback, window, result);
            //}
            switch (result.type) {
                case 'notification' : {
                    console.log('notification');
                    console.log(result);
                    _this.emit('notification', result.data);
                    break;
                }
                case 'init' : {
                    console.log('init');
                    console.log(result);
                    _this.emit('init', result.data);
                    break;
                }
            }
        };

        // triggered on error
        var fail = function fail(msg) {
            var e = typeof msg === 'string' ? new Error(msg) : msg;
            _this.emit('error', e);
        };

        setTimeout(function () {
            exec(success, fail, 'NotificationPlugin', 'init', [params]);
        }, 10);
    }

    _createClass(NotificationPlugin, [{
        // internal use only!
        key: 'emit',
        value: function emit() {
            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
            }

            var eventName = args.shift();

            if (!this.handlers.hasOwnProperty(eventName)) {
                return false;
            }

            for (var i = 0, length = this.handlers[eventName].length; i < length; i++) {
                var callback = this.handlers[eventName][i];
                if (typeof callback === 'function') {
                    callback.apply(undefined, args);
                } else {
                    console.log('event handler: ' + eventName + ' must be a function');
                }
            }

            return true;
        }
    }, {
        key: 'on',
        value: function on(eventName, callback) {
            if (!this.handlers.hasOwnProperty(eventName)) {
                this.handlers[eventName] = [];
            }
            this.handlers[eventName].push(callback);
        }
    }, {
        key: 'off',
        value: function off(eventName, handle) {
            if (this.handlers.hasOwnProperty(eventName)) {
                var handleIndex = this.handlers[eventName].indexOf(handle);
                if (handleIndex >= 0) {
                    this.handlers[eventName].splice(handleIndex, 1);
                }
            }
        }
    }
        //{
        //    key: 'unregister',
        //    value: function unregister(successCallback) {
        //        var _this2 = this;
        //
        //        var errorCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {
        //        };
        //        var options = arguments[2];
        //
        //        if (typeof errorCallback !== 'function') {
        //            console.log('PushNotification.unregister failure: failure parameter not a function');
        //            return;
        //        }
        //
        //        if (typeof successCallback !== 'function') {
        //            console.log('PushNotification.unregister failure: success callback parameter ' + ' must be a function');
        //            return;
        //        }
        //
        //        var cleanHandlersAndPassThrough = function cleanHandlersAndPassThrough() {
        //            if (!options) {
        //                _this2.handlers = {
        //                    registration: [],
        //                    notification: [],
        //                    error: []
        //                };
        //            }
        //            successCallback();
        //        };
        //
        //        exec(cleanHandlersAndPassThrough, errorCallback, 'PushNotification', 'unregister', [options]);
        //    }
        //}
    ]);

    return NotificationPlugin;
}();

//NotificationPlugin.schedule = function (params, success, error) {
//    exec(success, error, "NotificationPlugin", "schedule", [params]);
//};
//
//NotificationPlugin.remove = function (params, success, error) {
//    exec(success, error, "NotificationPlugin", "remove", [params]);
//};
//
//NotificationPlugin.hasPermission = function (params, success, error) {
//    exec(success, error, "NotificationPlugin", "hasPermission", [params]);
//};
//
//NotificationPlugin.init = function (params, success, error) {
//    setTimeout(function () {
//        exec(success, error, "NotificationPlugin", "init", [params]);
//    }, 10);
//};

module.exports = {

    init: function init(params) {
        return new NotificationPlugin(params);
    },

    hasPermission: function (params, success, error) {
        exec(success, error, "NotificationPlugin", "hasPermission", [params]);
    },

    schedule: function (params, success, error) {
        exec(success, error, "NotificationPlugin", "schedule", [params]);
    },

    remove: function (params, success, error) {
        exec(success, error, "NotificationPlugin", "remove", [params]);
    },
	
	cleanup: function (params, success, error) {
		exec(success, error, "NotificationPlugin", "cleanup", [params]);
	},
	
	cleanupPushNotifications: function (params, success, error) {
		exec(success, error, "NotificationPlugin", "cleanupPushNotifications", [params]);
	},
	
	listChannels: function (params, success, error) {
		exec(success, error, "NotificationPlugin", "listChannels", [params]);
	}

};

});
